-- Common Help function for plugins by David Down
-- coding: utf-8
local pre
local function print(text) Turbine.Shell.WriteLine("<rgb=#00FFFF>"..pre..":</rgb> "..text) end
local function printh(text) print("<rgb=#00FF00>"..text.."</rgb>") end

function Help(help,arg)
    pre = help.pre
    if not arg then
        print(help.help)
    elseif arg=='?' then
        printh("Possible command arguments:")
        for name,text in pairs(help.arg) do
            print(name..' - '..text)
        end
    elseif arg=='??' then
        printh("Possible commands:")
        for name,val in pairs(help.cmd) do
            local str,text = name,val
            if type(val)=="table" then 
                str = str.." ?"
                text = val[" "] 
            end
            print('/'..str..' - '..text)
        end
    elseif help.cmd and help.cmd[arg] then
        if type(help.cmd[arg]) == "table" then
            printh("Possible '/"..arg.."' arguments:")
            for name,text in pairs(help.cmd[arg]) do
                print(name..' - '..text)
            end
        else print(arg..' - '..help.cmd[arg]) end
    elseif help[arg] then
        print(help[arg])
    else print(help['?']) end
end